summaryrefslogtreecommitdiff
path: root/home
diff options
context:
space:
mode:
Diffstat (limited to 'home')
-rw-r--r--home/xyz/.Xresources11
-rw-r--r--home/xyz/.bashrc105
-rw-r--r--home/xyz/.config/Mullvad VPN/gui_settings.json1
-rw-r--r--home/xyz/.config/aria2/aria2.conf2
-rw-r--r--home/xyz/.config/dunst/dunstrc432
-rw-r--r--home/xyz/.config/fcitx5/conf/chttrans.conf12
-rw-r--r--home/xyz/.config/fcitx5/conf/classicui.conf15
-rw-r--r--home/xyz/.config/fcitx5/conf/pinyin.conf113
-rw-r--r--home/xyz/.config/fcitx5/config71
-rw-r--r--home/xyz/.config/fcitx5/profile23
-rw-r--r--home/xyz/.config/fontconfig/fonts.conf44
-rw-r--r--home/xyz/.config/htop/htoprc44
-rw-r--r--home/xyz/.config/mimeapps.list11
l---------home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua1
-rw-r--r--home/xyz/.config/myconf/gallery_urls5
-rw-r--r--home/xyz/.config/newsboat/config27
-rw-r--r--home/xyz/.config/newsboat/urls23
-rwxr-xr-xhome/xyz/.config/nsxiv/exec/key-handler65
-rw-r--r--home/xyz/.config/readline/inputrc39
-rw-r--r--home/xyz/.config/sxhkd/sxhkdrc64
-rw-r--r--home/xyz/.config/systemd/user/ssh-agent.service24
-rw-r--r--home/xyz/.config/user-dirs.dirs15
-rw-r--r--home/xyz/.config/zathura/zathurarc2
-rwxr-xr-xhome/xyz/.local/bin/alarm9
-rwxr-xr-xhome/xyz/.local/bin/bell7
-rwxr-xr-xhome/xyz/.local/bin/ccgsl7
-rwxr-xr-xhome/xyz/.local/bin/cfg27
-rwxr-xr-xhome/xyz/.local/bin/chmodef6
-rwxr-xr-xhome/xyz/.local/bin/convwall34
-rwxr-xr-xhome/xyz/.local/bin/curlkg52
-rwxr-xr-xhome/xyz/.local/bin/curlncm75
-rwxr-xr-xhome/xyz/.local/bin/curlqb13
-rwxr-xr-xhome/xyz/.local/bin/gita18
-rwxr-xr-xhome/xyz/.local/bin/gitfork8
-rwxr-xr-xhome/xyz/.local/bin/gitmetap17
-rwxr-xr-xhome/xyz/.local/bin/gitmetar7
-rwxr-xr-xhome/xyz/.local/bin/gitpu19
-rwxr-xr-xhome/xyz/.local/bin/lastarg5
-rwxr-xr-xhome/xyz/.local/bin/mmi27
-rwxr-xr-xhome/xyz/.local/bin/mpva15
-rwxr-xr-xhome/xyz/.local/bin/mpvy41
-rwxr-xr-xhome/xyz/.local/bin/mvln30
-rwxr-xr-xhome/xyz/.local/bin/mvt8
-rwxr-xr-xhome/xyz/.local/bin/mvtr14
-rwxr-xr-xhome/xyz/.local/bin/o25
-rwxr-xr-xhome/xyz/.local/bin/orgext18
-rwxr-xr-xhome/xyz/.local/bin/reco27
-rwxr-xr-xhome/xyz/.local/bin/sbar94
-rwxr-xr-xhome/xyz/.local/bin/shufwall9
-rwxr-xr-xhome/xyz/.local/bin/time.uuid6
-rwxr-xr-xhome/xyz/.local/bin/topa6
-rwxr-xr-xhome/xyz/.local/bin/upd126
-rwxr-xr-xhome/xyz/.local/bin/vinfo4
-rwxr-xr-xhome/xyz/.local/bin/wh11
-rwxr-xr-xhome/xyz/.local/bin/xmq3
-rw-r--r--home/xyz/.local/share/applications/file.desktop4
l---------home/xyz/.local/share/weechat/python/autoload/weechat-matrix.py1
-rw-r--r--home/xyz/.profile90
-rw-r--r--home/xyz/.xinitrc60
59 files changed, 2072 insertions, 0 deletions
diff --git a/home/xyz/.Xresources b/home/xyz/.Xresources
new file mode 100644
index 00000000..7f045804
--- /dev/null
+++ b/home/xyz/.Xresources
@@ -0,0 +1,11 @@
+! studio ture dpi
+!Xft.dpi: 131
+! studio fake dpi
+!Xft.dpi: 96
+
+! nsxiv, fnune/base16-vim base16-tomorrow-night colorscheme
+Nsxiv.bar.font:monospace:size=11
+Nsxiv.window.foreground:#c5c8c6
+Nsxiv.window.background:#1d1f21
+Nsxiv.bar.foreground:#b4b7b4
+Nsxiv.bar.background:#282a2e
diff --git a/home/xyz/.bashrc b/home/xyz/.bashrc
new file mode 100644
index 00000000..c70c90ba
--- /dev/null
+++ b/home/xyz/.bashrc
@@ -0,0 +1,105 @@
+#!/bin/bash
+
+# $- meaning see https://stackoverflow.com/questions/42757236/what-does-mean-in-bash
+# If not running interactively, don't do anything
+#[[ $- != *i* ]] && return
+# https://github.com/westscz/.dotfiles/blob/master/system/bashrc
+case $- in
+ *i*) ;;
+ *) return;;
+esac
+
+. /usr/share/fzf/completion.bash
+. /usr/share/fzf/key-bindings.bash
+
+# default PS1
+#PS1='[\u@\h \W]\$ '
+
+# depreciated
+# 0: not bold, 91: bright red
+# \e[m act like \e[0m, means reset so commands after it will not be colored
+# https://en.wikipedia.org/wiki/ANSI_escape_code#3-bit_and_4-bit
+# need \[ and \] around color codes so bash ignore color codes when calculating line wraps?
+# https://www.cyberciti.biz/faq/bash-shell-change-the-color-of-my-shell-prompt-under-linux-or-unix/#:~:text=you%20also%20need%20to%20put%20%5C%5B%20and%20%5C%5D%20around%20any%20color%20codes%20so%20that%20bash%20does%20not%20take%20them%20into%20account%20when%20calculating%20line%20wraps.
+#PS1='\[\e[0;91m\][\u@\h \W]\$ \[\e[0m\]'
+# \033 can be used for dash printf, but \e can't? not sure why
+#PS1='\[\033[0;91m\][\u@\h \W]\$ \[\033[0m\]'
+
+# tput is better for different terminals?
+# but also need \[ and \] around color code for PS1! but seems no need for printf in script? why?
+# setaf and sgr0 see `man terminfo`
+PS1="\[$(tput setaf 1)\][\u@\h \W]\$ \[$(tput sgr0)\]"
+
+# https://github.com/LukeSmithxyz/voidrice/blob/master/.config/shell/aliasrc
+for cmd in iotop nethogs hardcode-fixer ventoy du; do
+ alias $cmd="sudo $cmd"
+done
+unset cmd
+
+# same name
+alias absolutely-proprietary='absolutely-proprietary -f'
+alias alsamixer='alsamixer -V all'
+alias diff='diff --color=auto'
+alias grep='grep --color=auto'
+alias info='info --vi-keys'
+alias ls='ls --color=auto'
+alias radeontop='radeontop -c'
+alias rm='rm -I'
+alias sdcv='sdcv --color'
+alias shellcheck='shellcheck -x'
+alias tree='tree -a'
+alias uname='uname -a'
+
+# different name
+# /dev/ttyACM0 can be in config file, or as environmantal variable, see /usr/share/doc/adafruit-ampy/README.md
+alias ap='sudo ampy -p /dev/ttyACM0'
+alias c=cfg
+alias g=git
+alias l='\ls --color=auto -A --group-directories-first'
+alias ll='\ls --color=auto -lAh --group-directories-first'
+alias m=man
+alias p=pacman
+alias pu=paru
+alias s='sudo ' # https://askubuntu.com/a/22043
+alias se='sudo -E '
+alias spd='speedtest --no-upload; librespeed-cli --no-upload'
+alias sv='sudoedit'
+alias tp='sudo tio /dev/ttyACM0'
+alias v='$EDITOR'
+alias vc='$EDITOR "$XDG_DOCUMENTS_DIR/notes/computer/cli_notes.md"'
+alias vq='$EDITOR "$XDG_DOCUMENTS_DIR/notes/others/questions_ideas_tips.md"'
+alias vvrc='$EDITOR +e\ \$MYVIMRC'
+alias wtr='mullvad-exclude curl v2.wttr.in?m'
+alias za='zoxide add'
+
+# almost never use
+#alias zq='zoxide query'
+#alias zqi='zoxide query -i'
+
+# depreciated
+# all green color, no auto turn off color when pipe to nvim
+#alias pactree='pactree -c'
+
+#eval "$(zoxide init posix --hook prompt --no-aliases)"
+# if no --no-aliases, when tab complete a dir name contain spaces, bash will not escape spaces, don't know why, maybe bug?
+eval "$(zoxide init bash --no-aliases)"
+
+z () {
+ __zoxide_z "$@" && l
+}
+
+zi () {
+ __zoxide_zi "$@" && l
+}
+
+# steal from fzf: https://github.com/junegunn/fzf/blob/master/shell/key-bindings.bash
+# READLINE_LINE and READLINE_POINT see `man bash`
+zqi_key () {
+ # fzf uses printf '%q' to escape output, but attention %q is not POSIX
+ # well we use bash here so whatever
+ selected=$(printf '%q ' "$(zoxide query -i)")
+ READLINE_LINE="${READLINE_LINE:0:$READLINE_POINT}$selected${READLINE_LINE:$READLINE_POINT}"
+ READLINE_POINT=$((READLINE_POINT+${#selected}))
+}
+bind -m vi-command -x '"\C-o":zqi_key'
+bind -m vi-insert -x '"\C-o":zqi_key'
diff --git a/home/xyz/.config/Mullvad VPN/gui_settings.json b/home/xyz/.config/Mullvad VPN/gui_settings.json
new file mode 100644
index 00000000..8867e15e
--- /dev/null
+++ b/home/xyz/.config/Mullvad VPN/gui_settings.json
@@ -0,0 +1 @@
+{"preferredLocale":"system","autoConnect":true,"enableSystemNotifications":true,"monochromaticIcon":false,"startMinimized":false,"unpinnedWindow":true,"browsedForSplitTunnelingApplications":[]} \ No newline at end of file
diff --git a/home/xyz/.config/aria2/aria2.conf b/home/xyz/.config/aria2/aria2.conf
new file mode 100644
index 00000000..44bd9c97
--- /dev/null
+++ b/home/xyz/.config/aria2/aria2.conf
@@ -0,0 +1,2 @@
+# max hardcoded to 16, see https://github.com/aria2/aria2/issues/1039
+max-connection-per-server=16
diff --git a/home/xyz/.config/dunst/dunstrc b/home/xyz/.config/dunst/dunstrc
new file mode 100644
index 00000000..7d0fea5a
--- /dev/null
+++ b/home/xyz/.config/dunst/dunstrc
@@ -0,0 +1,432 @@
+# See dunst(5) for all configuration options
+
+[global]
+ ### Display ###
+
+ # Which monitor should the notifications be displayed on.
+ monitor = 0
+
+ # Display notification on focused monitor. Possible modes are:
+ # mouse: follow mouse pointer
+ # keyboard: follow window with keyboard focus
+ # none: don't follow anything
+ #
+ # "keyboard" needs a window manager that exports the
+ # _NET_ACTIVE_WINDOW property.
+ # This should be the case for almost all modern window managers.
+ #
+ # If this option is set to mouse or keyboard, the monitor option
+ # will be ignored.
+ follow = mouse
+
+ ### Geometry ###
+
+ # dynamic width from 0 to 300
+ # width = (0, 300)
+ # constant width of 300
+ width = (0,300)
+
+ # The maximum height of a single notification, excluding the frame.
+ height = 300
+
+ # Position the notification in the top right corner
+ origin = top-right
+
+ # Offset from the origin
+ offset = 0x21
+
+ # Scale factor. It is auto-detected if value is 0.
+ scale = 0
+
+ # Maximum number of notification (0 means no limit)
+ notification_limit = 5
+
+ ### Progress bar ###
+
+ # Turn on the progess bar. It appears when a progress hint is passed with
+ # for example dunstify -h int:value:12
+ progress_bar = true
+
+ # Set the progress bar height. This includes the frame, so make sure
+ # it's at least twice as big as the frame width.
+ progress_bar_height = 10
+
+ # Set the frame width of the progress bar
+ progress_bar_frame_width = 1
+
+ # Set the minimum width for the progress bar
+ progress_bar_min_width = 150
+
+ # Set the maximum width for the progress bar
+ progress_bar_max_width = 300
+
+
+ # Show how many messages are currently hidden (because of
+ # notification_limit).
+ indicate_hidden = yes
+
+ # The transparency of the window. Range: [0; 100].
+ # This option will only work if a compositing window manager is
+ # present (e.g. xcompmgr, compiz, etc.). (X11 only)
+ transparency = 0
+
+ # Draw a line of "separator_height" pixel height between two
+ # notifications.
+ # Set to 0 to disable.
+ separator_height = 1
+
+ # Padding between text and separator.
+ padding = 8
+
+ # Horizontal padding.
+ horizontal_padding = 8
+
+ # Padding between text and icon.
+ text_icon_padding = 0
+
+ # Defines width in pixels of frame around the notification window.
+ # Set to 0 to disable.
+ frame_width = 1
+
+ # Defines color of the frame around the notification window.
+ frame_color = "#c5c8c6"
+
+ # Define a color for the separator.
+ # possible values are:
+ # * auto: dunst tries to find a color fitting to the background;
+ # * foreground: use the same color as the foreground;
+ # * frame: use the same color as the frame;
+ # * anything else will be interpreted as a X color.
+ separator_color = frame
+
+ # Sort messages by urgency.
+ sort = yes
+
+ # Don't remove messages, if the user is idle (no mouse or keyboard input)
+ # for longer than idle_threshold seconds.
+ # Set to 0 to disable.
+ # A client can set the 'transient' hint to bypass this. See the rules
+ # section for how to disable this if necessary
+ idle_threshold = 120
+
+ ### Text ###
+
+ font = Monospace 10
+
+ # The spacing between lines. If the height is smaller than the
+ # font height, it will get raised to the font height.
+ line_height = 0
+
+ # Possible values are:
+ # full: Allow a small subset of html markup in notifications:
+ # <b>bold</b>
+ # <i>italic</i>
+ # <s>strikethrough</s>
+ # <u>underline</u>
+ #
+ # For a complete reference see
+ # <https://developer.gnome.org/pango/stable/pango-Markup.html>.
+ #
+ # strip: This setting is provided for compatibility with some broken
+ # clients that send markup even though it's not enabled on the
+ # server. Dunst will try to strip the markup but the parsing is
+ # simplistic so using this option outside of matching rules for
+ # specific applications *IS GREATLY DISCOURAGED*.
+ #
+ # no: Disable markup parsing, incoming notifications will be treated as
+ # plain text. Dunst will not advertise that it has the body-markup
+ # capability if this is set as a global setting.
+ #
+ # It's important to note that markup inside the format option will be parsed
+ # regardless of what this is set to.
+ markup = full
+
+ # The format of the message. Possible variables are:
+ # %a appname
+ # %s summary
+ # %b body
+ # %i iconname (including its path)
+ # %I iconname (without its path)
+ # %p progress value if set ([ 0%] to [100%]) or nothing
+ # %n progress value if set without any extra characters
+ # %% Literal %
+ # Markup is allowed
+ format = "<b>%s</b>\n%b"
+
+ # Alignment of message text.
+ # Possible values are "left", "center" and "right".
+ alignment = left
+
+ # Vertical alignment of message text and icon.
+ # Possible values are "top", "center" and "bottom".
+ vertical_alignment = center
+
+ # Show age of message if message is older than show_age_threshold
+ # seconds.
+ # Set to -1 to disable.
+ show_age_threshold = 60
+
+ # Specify where to make an ellipsis in long lines.
+ # Possible values are "start", "middle" and "end".
+ ellipsize = middle
+
+ # Ignore newlines '\n' in notifications.
+ ignore_newline = no
+
+ # Stack together notifications with the same content
+ stack_duplicates = true
+
+ # Hide the count of stacked notifications with the same content
+ hide_duplicate_count = false
+
+ # Display indicators for URLs (U) and actions (A).
+ show_indicators = yes
+
+ ### Icons ###
+
+ # Align icons left/right/off
+ icon_position = left
+
+ # Scale small icons up to this size, set to 0 to disable. Helpful
+ # for e.g. small files or high-dpi screens. In case of conflict,
+ # max_icon_size takes precedence over this.
+ min_icon_size = 0
+
+ # Scale larger icons down to this size, set to 0 to disable
+ max_icon_size = 32
+
+ # Paths to default icons.
+ icon_path = /usr/share/icons/Papirus-Dark/16x16/actions:/usr/share/icons/Papirus-Dark/16x16/categories:/usr/share/icons/Papirus-Dark/16x16/emblems:/usr/share/icons/Papirus-Dark/16x16/mimetypes:/usr/share/icons/Papirus-Dark/16x16/places:/usr/share/icons/Papirus-Dark/16x16/apps:/usr/share/icons/Papirus-Dark/16x16/devices:/usr/share/icons/Papirus-Dark/16x16/emotes:/usr/share/icons/Papirus-Dark/16x16/panel:/usr/share/icons/Papirus-Dark/16x16/status
+
+ ### History ###
+
+ # Should a notification popped up from history be sticky or timeout
+ # as if it would normally do.
+ sticky_history = yes
+
+ # Maximum amount of notifications kept in history
+ history_length = 20
+
+ ### Misc/Advanced ###
+
+ # dmenu path.
+ dmenu = /usr/bin/dmenu -p dunst:
+
+ # Browser for opening urls in context menu.
+ browser = /usr/bin/xdg-open
+
+ # Always run rule-defined scripts, even if the notification is suppressed
+ always_run_script = true
+
+ # Define the title of the windows spawned by dunst
+ title = Dunst
+
+ # Define the class of the windows spawned by dunst
+ class = Dunst
+
+ # Define the corner radius of the notification window
+ # in pixel size. If the radius is 0, you have no rounded
+ # corners.
+ # The radius will be automatically lowered if it exceeds half of the
+ # notification height to avoid clipping text and/or icons.
+ corner_radius = 0
+
+ # Ignore the dbus closeNotification message.
+ # Useful to enforce the timeout set by dunst configuration. Without this
+ # parameter, an application may close the notification sent before the
+ # user defined timeout.
+ ignore_dbusclose = false
+
+ ### Wayland ###
+ # These settings are Wayland-specific. They have no effect when using X11
+
+ # Uncomment this if you want to let notications appear under fullscreen
+ # applications (default: overlay)
+ # layer = top
+
+ # Set this to true to use X11 output on Wayland.
+ force_xwayland = false
+
+ ### Legacy
+
+ # Use the Xinerama extension instead of RandR for multi-monitor support.
+ # This setting is provided for compatibility with older nVidia drivers that
+ # do not support RandR and using it on systems that support RandR is highly
+ # discouraged.
+ #
+ # By enabling this setting dunst will not be able to detect when a monitor
+ # is connected or disconnected which might break follow mode if the screen
+ # layout changes.
+ force_xinerama = false
+
+ ### mouse
+
+ # Defines list of actions for each mouse event
+ # Possible values are:
+ # * none: Don't do anything.
+ # * do_action: Invoke the action determined by the action_name rule. If there is no
+ # such action, open the context menu.
+ # * open_url: If the notification has exactly one url, open it. If there are multiple
+ # ones, open the context menu.
+ # * close_current: Close current notification.
+ # * close_all: Close all notifications.
+ # * context: Open context menu for the notification.
+ # * context_all: Open context menu for all notifications.
+ # These values can be strung together for each mouse event, and
+ # will be executed in sequence.
+ mouse_left_click = close_current
+ mouse_middle_click = do_action, close_current
+ mouse_right_click = close_all
+
+# Experimental features that may or may not work correctly. Do not expect them
+# to have a consistent behaviour across releases.
+[experimental]
+ # Calculate the dpi to use on a per-monitor basis.
+ # If this setting is enabled the Xft.dpi value will be ignored and instead
+ # dunst will attempt to calculate an appropriate dpi value for each monitor
+ # using the resolution and physical size. This might be useful in setups
+ # where there are multiple screens with very different dpi values.
+ per_monitor_dpi = false
+
+
+[urgency_low]
+ # IMPORTANT: colors have to be defined in quotation marks.
+ # Otherwise the "#" and following would be interpreted as a comment.
+ background = "#1d1f21"
+ foreground = "#81a2be"
+ frame_color = "#81a2be"
+ timeout = 10
+ # Icon for notifications with low urgency, uncomment to enable
+ #icon = /path/to/icon
+
+[urgency_normal]
+ background = "#1d1f21"
+ foreground = "#b5bd68"
+ frame_color = "#b5bd68"
+ timeout = 10
+ # Icon for notifications with normal urgency, uncomment to enable
+ #icon = /path/to/icon
+
+[urgency_critical]
+ background = "#1d1f21"
+ foreground = "#cc6666"
+ frame_color = "#cc6666"
+ timeout = 0
+ # Icon for notifications with critical urgency, uncomment to enable
+ #icon = /path/to/icon
+
+# Every section that isn't one of the above is interpreted as a rules to
+# override settings for certain messages.
+#
+# Messages can be matched by
+# appname (discouraged, see desktop_entry)
+# body
+# category
+# desktop_entry
+# icon
+# match_transient
+# msg_urgency
+# stack_tag
+# summary
+#
+# and you can override the
+# background
+# foreground
+# format
+# frame_color
+# fullscreen
+# new_icon
+# set_stack_tag
+# set_transient
+# timeout
+# urgency
+# action_name
+#
+# Shell-like globbing will get expanded.
+#
+# Instead of the appname filter, it's recommended to use the desktop_entry filter.
+# GLib based applications export their desktop-entry name. In comparison to the appname,
+# the desktop-entry won't get localized.
+#
+# SCRIPTING
+# You can specify a script that gets run when the rule matches by
+# setting the "script" option.
+# The script will be called as follows:
+# script appname summary body icon urgency
+# where urgency can be "LOW", "NORMAL" or "CRITICAL".
+#
+# NOTE: It might be helpful to run dunst -print in a terminal in order
+# to find fitting options for rules.
+
+# Disable the transient hint so that idle_threshold cannot be bypassed from the
+# client
+#[transient_disable]
+# match_transient = yes
+# set_transient = no
+#
+# Make the handling of transient notifications more strict by making them not
+# be placed in history.
+#[transient_history_ignore]
+# match_transient = yes
+# history_ignore = yes
+
+# fullscreen values
+# show: show the notifications, regardless if there is a fullscreen window opened
+# delay: displays the new notification, if there is no fullscreen window active
+# If the notification is already drawn, it won't get undrawn.
+# pushback: same as delay, but when switching into fullscreen, the notification will get
+# withdrawn from screen again and will get delayed like a new notification
+#[fullscreen_delay_everything]
+# fullscreen = delay
+#[fullscreen_show_critical]
+# msg_urgency = critical
+# fullscreen = show
+
+#[espeak]
+# summary = "*"
+# script = dunst_espeak.sh
+
+#[script-test]
+# summary = "*script*"
+# script = dunst_test.sh
+
+#[ignore]
+# # This notification will not be displayed
+# summary = "foobar"
+# skip_display = true
+
+#[history-ignore]
+# # This notification will not be saved in history
+# summary = "foobar"
+# history_ignore = yes
+
+#[skip-display]
+# # This notification will not be displayed, but will be included in the history
+# summary = "foobar"
+# skip_display = yes
+
+#[signed_on]
+# appname = Pidgin
+# summary = "*signed on*"
+# urgency = low
+#
+#[signed_off]
+# appname = Pidgin
+# summary = *signed off*
+# urgency = low
+#
+#[says]
+# appname = Pidgin
+# summary = *says*
+# urgency = critical
+#
+#[twitter]
+# appname = Pidgin
+# summary = *twitter.com*
+# urgency = normal
+#
+#[stack-volumes]
+# appname = "some_volume_notifiers"
+# set_stack_tag = "volume"
+#
+# vim: ft=cfg
diff --git a/home/xyz/.config/fcitx5/conf/chttrans.conf b/home/xyz/.config/fcitx5/conf/chttrans.conf
new file mode 100644
index 00000000..cb546117
--- /dev/null
+++ b/home/xyz/.config/fcitx5/conf/chttrans.conf
@@ -0,0 +1,12 @@
+# Translate engine
+Engine=Native
+# Enabled Input Methods
+EnabledIM=
+# OpenCC profile for Simplified to Traditional
+OpenCCS2TProfile=
+# OpenCC profile for Traditional to Simplified
+OpenCCT2SProfile=
+
+[Hotkey]
+0=Control+Shift+F
+
diff --git a/home/xyz/.config/fcitx5/conf/classicui.conf b/home/xyz/.config/fcitx5/conf/classicui.conf
new file mode 100644
index 00000000..80f4e743
--- /dev/null
+++ b/home/xyz/.config/fcitx5/conf/classicui.conf
@@ -0,0 +1,15 @@
+# Vertical Candidate List
+Vertical Candidate List=False
+# Use Per Screen DPI
+PerScreenDPI=True
+# Use mouse wheel to go to prev or next page
+WheelForPaging=True
+# Font
+Font="Adobe Kaiti Std 16"
+# Menu Font
+MenuFont="Sans 10"
+# Use input method language to display text
+UseInputMethodLangaugeToDisplayText=True
+# Theme
+Theme=default
+
diff --git a/home/xyz/.config/fcitx5/conf/pinyin.conf b/home/xyz/.config/fcitx5/conf/pinyin.conf
new file mode 100644
index 00000000..b9cf8093
--- /dev/null
+++ b/home/xyz/.config/fcitx5/conf/pinyin.conf
@@ -0,0 +1,113 @@
+# Shuangpin Profile
+ShuangpinProfile=Ziranma
+# Show current shuangpin mode
+ShowShuangpinMode=True
+# Page size
+PageSize=5
+# Enable Spell
+SpellEnabled=True
+# Enable Emoji
+EmojiEnabled=True
+# Enable Chaizi
+ChaiziEnabled=True
+# Enable Cloud Pinyin
+CloudPinyinEnabled=False
+# Cloud Pinyin Index
+CloudPinyinIndex=2
+# Show preedit within application
+PreeditInApplication=False
+# Fix embedded preedit cursor at the beginning of the preedit
+PreeditCursorPositionAtBeginning=True
+# Show complete pinyin in preedit
+PinyinInPreedit=True
+# Enable Prediction
+Prediction=False
+# Prediction Size
+PredictionSize=10
+# Select 2nd Candidate
+SecondCandidate=
+# Select 3rd Candidate
+ThirdCandidate=
+# Number of Sentence
+Number of sentence=2
+# Prompt long word length when input length over (0 for disable)
+LongWordLengthLimit=4
+# Key to trigger quickphrase
+QuickPhraseKey=semicolon
+# Use V to trigger quickphrase
+VAsQuickphrase=False
+# FirstRun
+FirstRun=False
+
+[ForgetWord]
+0=Control+7
+
+[PrevPage]
+0=minus
+1=Up
+
+[NextPage]
+0=equal
+1=Down
+
+[PrevCandidate]
+0=Shift+Tab
+
+[NextCandidate]
+0=Tab
+
+[ChooseCharFromPhrase]
+0=bracketleft
+1=bracketright
+
+[FilterByStroke]
+0=grave
+
+[QuickPhrase trigger]
+0=www.
+1=ftp.
+2=http:
+3=mail.
+4=bbs.
+5=forum.
+6=https:
+7=ftp:
+8=telnet:
+9=mailto:
+
+[Fuzzy]
+# ue -> ve
+VE_UE=True
+# gn -> ng
+NG_GN=True
+# Inner Segment (xian -> xi'an)
+Inner=True
+# Inner Segment for Short Pinyin (qie -> qi'e)
+InnerShort=True
+# Match partial finals (e -> en, eng, ei)
+PartialFinal=True
+# u <-> v
+V_U=False
+# an <-> ang
+AN_ANG=False
+# en <-> eng
+EN_ENG=True
+# ian <-> iang
+IAN_IANG=False
+# in <-> ing
+IN_ING=True
+# u <-> ou
+U_OU=False
+# uan <-> uang
+UAN_UANG=False
+# c <-> ch
+C_CH=False
+# f <-> h
+F_H=False
+# l <-> n
+L_N=False
+# s <-> sh
+S_SH=False
+# z <-> zh
+Z_ZH=False
+
diff --git a/home/xyz/.config/fcitx5/config b/home/xyz/.config/fcitx5/config
new file mode 100644
index 00000000..654a6b73
--- /dev/null
+++ b/home/xyz/.config/fcitx5/config
@@ -0,0 +1,71 @@
+[Hotkey]
+# Enumerate when press trigger key repeatedly
+EnumerateWithTriggerKeys=False
+# Enumerate Input Method Forward
+EnumerateForwardKeys=
+# Enumerate Input Method Backward
+EnumerateBackwardKeys=
+# Skip first input method while enumerating
+EnumerateSkipFirst=False
+# Enumerate Input Method Group Forward
+EnumerateGroupForwardKeys=
+# Enumerate Input Method Group Backward
+EnumerateGroupBackwardKeys=
+# Activate Input Method
+ActivateKeys=
+# Deactivate Input Method
+DeactivateKeys=
+
+[Hotkey/TriggerKeys]
+0=Control+space
+
+[Hotkey/AltTriggerKeys]
+0=Shift_L
+
+[Hotkey/PrevPage]
+0=Up
+
+[Hotkey/NextPage]
+0=Down
+
+[Hotkey/PrevCandidate]
+0=Shift+Tab
+
+[Hotkey/NextCandidate]
+0=Tab
+
+[Hotkey/TogglePreedit]
+0=Control+Alt+P
+
+[Behavior]
+# Active By Default
+ActiveByDefault=False
+# Share Input State
+ShareInputState=No
+# Show preedit in application
+PreeditEnabledByDefault=False
+# Show Input Method Information when switch input method
+ShowInputMethodInformation=True
+# Show Input Method Information when changing focus
+showInputMethodInformationWhenFocusIn=False
+# Show compact input method information
+CompactInputMethodInformation=True
+# Show first input method information
+ShowFirstInputMethodInformation=True
+# Default page size
+DefaultPageSize=5
+# Force Enabled Addons
+EnabledAddons=
+# Preload input method to be used by default
+PreloadInputMethod=True
+
+[Behavior/DisabledAddons]
+0=clipboard
+1=cloudpinyin
+2=fullwidth
+3=imselector
+4=kimpanel
+5=notificationitem
+6=spell
+7=wayland
+
diff --git a/home/xyz/.config/fcitx5/profile b/home/xyz/.config/fcitx5/profile
new file mode 100644
index 00000000..53325752
--- /dev/null
+++ b/home/xyz/.config/fcitx5/profile
@@ -0,0 +1,23 @@
+[Groups/0]
+# Group Name
+Name=Default
+# Layout
+Default Layout=us
+# Default Input Method
+DefaultIM=pinyin
+
+[Groups/0/Items/0]
+# Name
+Name=keyboard-us
+# Layout
+Layout=
+
+[Groups/0/Items/1]
+# Name
+Name=pinyin
+# Layout
+Layout=
+
+[GroupOrder]
+0=Default
+
diff --git a/home/xyz/.config/fontconfig/fonts.conf b/home/xyz/.config/fontconfig/fonts.conf
new file mode 100644
index 00000000..c8b6287f
--- /dev/null
+++ b/home/xyz/.config/fontconfig/fonts.conf
@@ -0,0 +1,44 @@
+<?xml version="1.0"?>
+<!DOCTYPE fontconfig SYSTEM "urn:fontconfig:fonts.dtd">
+<fontconfig>
+
+ <!-- more details: http://www.jinbuguo.com/gui/linux_fontconfig.html -->
+
+ <alias>
+ <family>serif</family>
+ <prefer>
+ <family>Noto Serif</family>
+ <family>Noto Serif CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+ <alias>
+ <family>sans-serif</family>
+ <prefer>
+ <family>Noto Sans</family>
+ <family>Noto Sans CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+ <alias>
+ <family>monospace</family>
+ <prefer>
+ <family>Noto Sans Mono</family>
+ <family>Noto Sans Mono CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+
+ <!-- man fonts-conf example approach -->
+ <!--
+ <match>
+ <test name="lang" compare="contains">
+ <string>zh</string>
+ </test>
+ <edit name="family" mode="prepend">
+ <string>Adobe Kaiti Std</string>
+ </edit>
+ </match>
+ -->
+
+</fontconfig>
diff --git a/home/xyz/.config/htop/htoprc b/home/xyz/.config/htop/htoprc
new file mode 100644
index 00000000..48d07e69
--- /dev/null
+++ b/home/xyz/.config/htop/htoprc
@@ -0,0 +1,44 @@
+# Beware! This file is rewritten by htop when settings are changed in the interface.
+# The parser is also very primitive, and not human-friendly.
+htop_version=3.1.0
+config_reader_min_version=2
+fields=0 48 17 18 38 39 40 2 46 47 49 1
+sort_key=46
+sort_direction=-1
+tree_sort_key=0
+tree_sort_direction=1
+hide_kernel_threads=1
+hide_userland_threads=1
+shadow_other_users=0
+show_thread_names=0
+show_program_path=1
+highlight_base_name=0
+highlight_deleted_exe=1
+highlight_megabytes=1
+highlight_threads=1
+highlight_changes=0
+highlight_changes_delay_secs=5
+find_comm_in_cmdline=1
+strip_exe_from_cmdline=1
+show_merged_command=0
+tree_view=0
+tree_view_always_by_pid=0
+all_branches_collapsed=0
+header_margin=1
+detailed_cpu_time=0
+cpu_count_from_one=0
+show_cpu_usage=1
+show_cpu_frequency=1
+show_cpu_temperature=1
+degree_fahrenheit=0
+update_process_names=0
+account_guest_in_cpu_meter=0
+color_scheme=0
+enable_mouse=1
+delay=15
+hide_function_bar=0
+header_layout=two_50_50
+column_meters_0=AllCPUs Memory Swap
+column_meter_modes_0=1 1 1
+column_meters_1=Tasks LoadAverage DiskIO NetworkIO
+column_meter_modes_1=2 2 2 2
diff --git a/home/xyz/.config/mimeapps.list b/home/xyz/.config/mimeapps.list
new file mode 100644
index 00000000..9beb62d2
--- /dev/null
+++ b/home/xyz/.config/mimeapps.list
@@ -0,0 +1,11 @@
+# it seems there's no need to put sxiv.desktop into ~/.local/share/applications/ if there exist sxiv.desktop in /usr/share/applications
+# no need to use xdg-mime to install it if already exist?
+# but if you what to create new .desktop desktop entries with new name, you need to put it in ~/.local/share/applications/
+
+[Default Applications]
+application/pdf=org.pwmt.zathura.desktop;
+application/epub+zip=org.pwmt.zathura.desktop;
+image/gif=nsxiv.desktop;
+image/jpeg=nsxiv.desktop;
+image/png=nsxiv.desktop;
+inode/directory=file.desktop;
diff --git a/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua b/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua
new file mode 120000
index 00000000..cb3390f8
--- /dev/null
+++ b/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua
@@ -0,0 +1 @@
+/usr/lib/mpv/sponsorblock-minimal.lua \ No newline at end of file
diff --git a/home/xyz/.config/myconf/gallery_urls b/home/xyz/.config/myconf/gallery_urls
new file mode 100644
index 00000000..0f128ec3
--- /dev/null
+++ b/home/xyz/.config/myconf/gallery_urls
@@ -0,0 +1,5 @@
+# input file format see https://github.com/mikf/gallery-dl/blob/13d4045a8a5a6fd45cb20df399f44055b25f5cca/gallery_dl/__init__.py#L33-L58
+#https://www.pixiv.net/users/13379747/artworks
+https://www.deviantart.com/wlop/gallery
+https://www.deviantart.com/minimalistic-animoo/gallery/
+https://www.deviantart.com/theminimalists/gallery/
diff --git a/home/xyz/.config/newsboat/config b/home/xyz/.config/newsboat/config
new file mode 100644
index 00000000..8b31ecb8
--- /dev/null
+++ b/home/xyz/.config/newsboat/config
@@ -0,0 +1,27 @@
+auto-reload yes
+
+bind-key h quit
+bind-key j down
+bind-key k up
+bind-key l open
+bind-key g home
+bind-key G end
+bind-key ^F pagedown
+bind-key ^B pageup
+
+# open-in-browser-noninteractively may be useful
+macro y set browser "echo %u | xsel -ib"; open-in-browser; set browser "$BROWSER %u &"
+
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_killfiles
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_filter_language
+
+# not sure if all following arch linux rss feed ignore-article will work as expected
+# maybe aur rss feed is broken; maybe arch linux feeds are updated very fast so I can't get the wanted news?
+# not fully understand the rss feed
+ignore-article "https://aur.archlinux.org/rss/" "title !~\"youtube-dlp|yt-dlp\""
+# arch linux development feeds: all project
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&project=0" "title !~ \"wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=edit&project=0" "title !~ \"FS#(47508|71501|71453|70113|69492)|wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=clo&project=0" "title !~ \"FS#(47508|71501|71453|70113|69492)|wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+
+# vim: ft=sh
diff --git a/home/xyz/.config/newsboat/urls b/home/xyz/.config/newsboat/urls
new file mode 100644
index 00000000..31858a4e
--- /dev/null
+++ b/home/xyz/.config/newsboat/urls
@@ -0,0 +1,23 @@
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_tagging
+
+# computer misc
+https://suckless.org/atom.xml
+https://ryf.fsf.org/news/rss.xml
+https://ryf.fsf.org/products/rss.xml
+https://git.savannah.gnu.org/cgit/gsl.git/atom/NEWS?h=master
+
+# arch linux
+https://archlinux.org/feeds/news/
+https://bbs.archlinux.org/extern.php?action=feed&tid=260286&type=atom
+https://aur.archlinux.org/rss/
+# arch linux development feeds: all projects
+https://bugs.archlinux.org/feed.php?feed_type=rss2&project=0
+https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=edit&project=0
+https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=clo&project=0
+
+# qmmp
+https://sourceforge.net/p/qmmp-dev/tickets/590/feed.atom
+https://sourceforge.net/p/qmmp-dev/tickets/714/feed.atom
+
+# recreation
+http://keygenmusic.net/rss.php
diff --git a/home/xyz/.config/nsxiv/exec/key-handler b/home/xyz/.config/nsxiv/exec/key-handler
new file mode 100755
index 00000000..a24b89b0
--- /dev/null
+++ b/home/xyz/.config/nsxiv/exec/key-handler
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+# Example for $XDG_CONFIG_HOME/sxiv/exec/key-handler
+# Called by sxiv(1) after the external prefix key (C-x by default) is pressed.
+# The next key combo is passed as its first argument. Passed via stdin are the
+# images to act upon, one path per line: all marked images, if in thumbnail
+# mode and at least one image has been marked, otherwise the current image.
+# sxiv(1) blocks until this script terminates. It then checks which images
+# have been modified and reloads them.
+
+# The key combo argument has the following form: "[C-][M-][S-]KEY",
+# where C/M/S indicate Ctrl/Meta(Alt)/Shift modifier states and KEY is the X
+# keysym as listed in /usr/include/X11/keysymdef.h without the "XK_" prefix.
+
+# my dependency notes
+# jpegtran is owned by libjpeg-turbo
+# mogrify is owned by imagemagick
+# exiv2 is owned by exiv2
+# rawtherapee is owned by rawtherapee
+
+rotate() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ case "$(file -b -i "$file")" in
+ image/jpeg*) jpegtran -rotate 90 -copy all -outfile "$file" "$file" ;;
+ *) mogrify -rotate 90 "$file" ;;
+ esac
+ done
+}
+
+flip() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ case "$(file -b -i "$file")" in
+ image/jpeg*) jpegtran -flip vertical -copy all -outfile "$file" "$file" ;;
+ *) mogrify -flip "$file" ;;
+ esac
+ done
+}
+
+linkwall() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ walldir="$XDG_PICTURES_DIR/wallpapers/"
+ name=$(basename "$file")
+ if [ ! -e "$walldir$name" ]; then
+ convwall "$file" "$walldir$name" || ln -s "$file" "$walldir"
+ else
+ notify-send 'error' "$name exist"
+ fi
+ done
+}
+
+# I choose not to put case nested in while read file loop
+# because it can pipe multiple files to one command?
+case "$1" in
+ "d") [ "$(printf 'No\nYes' | dmenu -i -p 'delete?')" = "Yes" ] && tr '\n' '\0' | xargs -0 rm ;;
+ "e") while read -r file; do alacritty -e sh -c "exiv2 pr -q -pa '$file' | less" & done ;;
+ "f") flip ;;
+ "g") tr '\n' '\0' | xargs -0 setsid -f gimp ;;
+ "l") linkwall ;;
+ "p") tr '\n' '\0' | xargs -0 sh -c 'convert "$@" $(time.uuid).pdf' shell ;;
+ "r") rotate ;;
+ "w") tr '\n' '\0' | xargs -0 shufwall ;;
+ # alternative using `xclip -in -selection clipboard`
+ "y") tr '\n' '\0' | xargs -0 realpath | tr '\n' '\0' | xargs -0 printf '%q ' | xsel -ib ;;
+esac
+
diff --git a/home/xyz/.config/readline/inputrc b/home/xyz/.config/readline/inputrc
new file mode 100644
index 00000000..b686fd80
--- /dev/null
+++ b/home/xyz/.config/readline/inputrc
@@ -0,0 +1,39 @@
+$include /etc/inputrc
+
+# from archwiki realine
+# Color files by types
+# Note that this may cause completion text blink in some terminals (e.g. xterm).
+set colored-stats On
+# Append char to indicate type
+set visible-stats On
+# Mark symlinked directories
+set mark-symlinked-directories On
+# Color the common prefix
+set colored-completion-prefix On
+# Color the common prefix in menu-complete
+set menu-complete-display-prefix On
+
+set editing-mode vi
+
+# https://github.com/LukeSmithxyz/voidrice/blob/2440ad83e9e9cf2f927efbaef618513e0df3cbda/.config/shell/inputrc
+$if mode=vi
+
+ set show-mode-in-prompt on
+ set vi-ins-mode-string \1\e[6 q\2
+ set vi-cmd-mode-string \1\e[2 q\2
+
+ #set keymap vi-command
+ # depreciated
+ # shell-expand-line expand all subshell `$()`? not perfect but ok
+ # if there's " or ', then after \\z the " and ' will be gone because shell-expand-line
+ # a lot of bugs compare to fzf's key-bindings.bash approach with `bind -x`
+ # zsh approach seems not easy too
+ # so I choose to just use a posix sh script
+ #"\\e": shell-expand-line
+ # https://unix.stackexchange.com/questions/439280/is-there-a-way-to-define-a-bash-readline-command
+ #"\\z": "a $(zoxide query -i)\e\\e"
+
+ set keymap vi-insert
+ "\C-l": clear-screen
+
+$endif
diff --git a/home/xyz/.config/sxhkd/sxhkdrc b/home/xyz/.config/sxhkd/sxhkdrc
new file mode 100644
index 00000000..960071e2
--- /dev/null
+++ b/home/xyz/.config/sxhkd/sxhkdrc
@@ -0,0 +1,64 @@
+Print
+ ffmpeg -f x11grab -i "$DISPLAY" -vframes 1 "$XDG_PICTURES_DIR/screenshots/$(time.uuid).png"
+
+alt + Print
+ xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -f x11grab -s "$1"x"$2" -i "$DISPLAY+$3,$4" -vframes 1 "$XDG_PICTURES_DIR/screenshots/$(time.uuid).png"' shell
+
+alt + shift + Print
+ reco
+
+XF86Audio{RaiseVolume,LowerVolume,Mute}
+ amixer set Master {5%+,5%-,toggle};\
+ kill -RTMIN+1 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+alt + XF86AudioMute
+ amixer set Capture toggle;\
+ kill -RTMIN "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+XF86Audio{Prev,Play,Next}
+ playerctl {previous,play-pause,next}
+
+@Caps_Lock
+ kill -RTMIN+3 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+alt + y
+ mpvy -s
+
+alt + shift + y
+ mpvy -a
+
+alt + ctrl + y
+ tsp mpvy -A -u "$(xsel -ob)"
+
+alt + w
+ "$BROWSER"
+
+# not ideal
+alt + shift + w
+ mullvad-exclude "$BROWSER"
+
+alt + s
+ shufwall
+
+# not ideal
+alt + v
+ if mullvad status | grep -q 'Disconnect'; then mullvad connect -w; else killall qbittorrent; mullvad disconnect -w; fi;\
+ kill -RTMIN+4 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+# not ideal
+alt + q
+ mullvad connect -w;\
+ kill -RTMIN+4 "$(cat "$XDG_CACHE_HOME/pidofbar")";\
+ qbittorrent
+
+# close dunst Notification
+alt + n
+ dunstctl close
+
+alt + shift + n
+ alarm 12 'Boiling Water!'
+
+alt + r
+ xsel -ob | rev | xsel -ib
+
+# vim: ft=sh
diff --git a/home/xyz/.config/systemd/user/ssh-agent.service b/home/xyz/.config/systemd/user/ssh-agent.service
new file mode 100644
index 00000000..66fa63ef
--- /dev/null
+++ b/home/xyz/.config/systemd/user/ssh-agent.service
@@ -0,0 +1,24 @@
+# how to use:
+# systemctl --user enable --now ssh-agent
+
+[Unit]
+Description=SSH key agent
+
+# archwiki approach
+# https://wiki.archlinux.org/title/SSH_keys#Start_ssh-agent_with_systemd_user
+[Service]
+Type=simple
+Environment=SSH_AUTH_SOCK=%t/ssh-agent.socket
+# DISPLAY required for ssh-askpass to work
+Environment=DISPLAY=:0
+ExecStart=/usr/bin/ssh-agent -D -a $SSH_AUTH_SOCK
+
+# github White-Oak approach
+# https://github.com/White-Oak/arch-setup-for-dummies/blob/master/setting-up-ssh-agent.md
+#[Service]
+#Type=forking
+#Environment=SSH_AUTH_SOCK=%t/ssh-agent.socket
+#ExecStart=/usr/bin/ssh-agent -a $SSH_AUTH_SOCK
+
+[Install]
+WantedBy=default.target
diff --git a/home/xyz/.config/user-dirs.dirs b/home/xyz/.config/user-dirs.dirs
new file mode 100644
index 00000000..85cab233
--- /dev/null
+++ b/home/xyz/.config/user-dirs.dirs
@@ -0,0 +1,15 @@
+# This file is written by xdg-user-dirs-update
+# If you want to change or add directories, just edit the line you're
+# interested in. All local changes will be retained on the next run.
+# Format is XDG_xxx_DIR="$HOME/yyy", where yyy is a shell-escaped
+# homedir-relative path, or XDG_xxx_DIR="/yyy", where /yyy is an
+# absolute path. No other format is supported.
+
+XDG_DESKTOP_DIR="$HOME/desktop/"
+XDG_DOWNLOAD_DIR="$HOME/downloads/"
+XDG_TEMPLATES_DIR="$HOME/"
+XDG_PUBLICSHARE_DIR="$HOME/"
+XDG_DOCUMENTS_DIR="$HOME/documents/"
+XDG_MUSIC_DIR="$HOME/music/"
+XDG_PICTURES_DIR="$HOME/pictures/"
+XDG_VIDEOS_DIR="$HOME/videos/"
diff --git a/home/xyz/.config/zathura/zathurarc b/home/xyz/.config/zathura/zathurarc
new file mode 100644
index 00000000..2c49960e
--- /dev/null
+++ b/home/xyz/.config/zathura/zathurarc
@@ -0,0 +1,2 @@
+# mouse selection copy to clipboard instead of primary
+set selection-clipboard clipboard
diff --git a/home/xyz/.local/bin/alarm b/home/xyz/.local/bin/alarm
new file mode 100755
index 00000000..9b366e19
--- /dev/null
+++ b/home/xyz/.local/bin/alarm
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+printf 'notify-send -u critical "%s"; bell' "${2:-alarm}" | at now + "$1" minutes && notify-send "Successfully Scheduled"
+
+# at used to not like string like 'Boiling Water!', don't know why now it works, if see similar issue, use folllowing codes
+#at now + "$1" minutes << EOF && notify-send 'Successfully Scheduled'
+#notify-send -u critical "${2:-alarm}"
+#bell
+#EOF
diff --git a/home/xyz/.local/bin/bell b/home/xyz/.local/bin/bell
new file mode 100755
index 00000000..c8bebd5e
--- /dev/null
+++ b/home/xyz/.local/bin/bell
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+bef="$(amixer get Master | awk -F '[][]' 'END{print $2}')"
+amixer set Master 20%
+# code steal from https://unix.stackexchange.com/a/163716/459013
+speaker-test -t sine -f 1000 -l 1
+amixer set Master "$bef"
diff --git a/home/xyz/.local/bin/ccgsl b/home/xyz/.local/bin/ccgsl
new file mode 100755
index 00000000..31bd3256
--- /dev/null
+++ b/home/xyz/.local/bin/ccgsl
@@ -0,0 +1,7 @@
+#!/bin/sh
+# steal codes from https://github.com/LukeSmithxyz/voidrice/blob/master/.local/bin/compiler
+
+base="${1%.*}"
+# -lm link math library? needed for sqrt(). not sure
+# https://stackoverflow.com/questions/44175151/what-is-the-meaning-of-lm-in-gcc
+cc -Wall -lgsl -lgslcblas -lm -o "$base" "$1" && ./"$base"
diff --git a/home/xyz/.local/bin/cfg b/home/xyz/.local/bin/cfg
new file mode 100755
index 00000000..299c6db9
--- /dev/null
+++ b/home/xyz/.local/bin/cfg
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+while getopts clsmM opt; do
+ case $opt in
+ c)
+ work_tree_dir="$HOME"
+ meta_file="$XDG_CONFIG_HOME/myconf/cfg${opt}_meta"
+ cmd="git --git-dir=$HOME/.cfg$opt/ --work-tree=$HOME"
+ ;;
+ l|s)
+ work_tree_dir=/
+ meta_file="/etc/myconf/cfg${opt}_meta"
+ cmd="sudo git --git-dir=/etc/.cfg$opt/ --work-tree=/"
+ ;;
+ m)
+ sudo gitmetap "$cmd" "$work_tree_dir" "$meta_file"
+ exit
+ ;;
+ M)
+ sudo gitmetar "$meta_file"
+ exit
+ ;;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+$cmd "$@"
diff --git a/home/xyz/.local/bin/chmodef b/home/xyz/.local/bin/chmodef
new file mode 100755
index 00000000..446bc230
--- /dev/null
+++ b/home/xyz/.local/bin/chmodef
@@ -0,0 +1,6 @@
+#!/bin/sh
+# chmodef: CHMOD DEFault
+
+# https://wiki.archlinux.org/title/File_permissions_and_attributes#Numeric_method
+find "$@" -type d -execdir chmod 755 -- '{}' \+
+find "$@" -type f -execdir chmod 644 -- '{}' \+
diff --git a/home/xyz/.local/bin/convwall b/home/xyz/.local/bin/convwall
new file mode 100755
index 00000000..dff9c43b
--- /dev/null
+++ b/home/xyz/.local/bin/convwall
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+# target image aspect ratio
+wratio=$SCR_WIDTH
+hratio=$SCR_HEIGHT
+# chop how much from center
+chopnum=99%
+
+# my benchmark shows -ping is much faster than default
+# https://github.com/ImageMagick/ImageMagick/issues/3183#issuecomment-800955241
+width=$(identify -ping -format '%w' "$1")
+height=$(identify -ping -format '%h' "$1")
+
+ratio=$((wratio*100/hratio))
+dim=$((width*100/height))
+
+if [ "$dim" -ne "$ratio" ]; then
+ if [ "$dim" -lt "$ratio" ]; then
+ chopgeom="${chopnum}x0"
+ width=$((height*wratio/hratio))
+ else
+ chopgeom="0x$chopnum"
+ height=$((width*hratio/wratio))
+ fi
+ # may throw error "sort: write failed: 'standard output': Broken pipe \n sort: write error"
+ # caused by head exit (or close stdin) before sort output complete, can ignore
+ # https://stackoverflow.com/questions/46202653/bash-error-in-sort-sort-write-failed-standard-output-broken-pipe
+ bgcolor=$(convert "$1" -gravity center -chop "$chopgeom" -define histogram:unique-colors=true -format %c histogram:info:- | sort -rn | head -n1 | awk \{print\ \$3\} | cut -c1-7)
+ # another approach is to use "$width" or "x$height" for geometry, current approach is more readable
+ convert "$1" -gravity center -background "$bgcolor" -extent "${width}x$height" "$2"
+else
+ echo 'same aspect ratio, no need to convert' >&2
+ exit 1
+fi
diff --git a/home/xyz/.local/bin/curlkg b/home/xyz/.local/bin/curlkg
new file mode 100755
index 00000000..4276e820
--- /dev/null
+++ b/home/xyz/.local/bin/curlkg
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+# references:
+# https://blog.csdn.net/qq_41730930/article/details/79327757
+# https://blog.csdn.net/u011112876/article/details/89634505
+# https://github.com/pystardust/ytfzf
+
+homepage_url='https://node.kg.qq.com/cgi/fcgi-bin/kg_ugc_get_homepage'
+music_url='https://node.kg.qq.com/cgi/fcgi-bin/fcg_get_play_url'
+# num seems only 8 and 15 works
+num=15
+tmp_file="$(mktemp)"
+
+get_json () {
+ curl -s -G --data-urlencode type=get_uinfo -d outCharset=utf-8 -d start="$1" -d num=$num -d share_uid="$uid" "$homepage_url" | sed 's/.*({\(.*\)}).*/{\1}/'
+}
+
+# concurrent file append with less than 4096 bytes will be atomic on arch linux ext4
+# so need to process json data before append to the file, to append less than 4096 bytes for each process
+# another appraoch is to use a loop to write to several files each corresponding to one process
+# https://stackoverflow.com/questions/1154446/is-file-append-atomic-in-unix
+# https://unix.stackexchange.com/questions/458653/parallel-processes-appending-outputs-to-an-array-in-a-bash-script
+process_json() {
+ jq -r '.data.ugclist[]|"'"$music_url"'?shareid=\(.shareid)\n out=\(.title)_\(.time).m4a"' >> "$tmp_file"
+}
+
+while getopts u: opt; do
+ case $opt in
+ u) uid="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+# for lan lan, uid=649b9e82272a348b
+# for cheng ruan, uid=64949d822c25328c
+[ -z "$uid" ] && echo 'error: must provide share_uid
+ex: curlkg -u 649b9e82272a348b ./' >&2 && exit 1
+shift $((OPTIND-1))
+download_dir="${1:-"$PWD"}"
+[ -d "$download_dir" ] || mkdir -p "$download_dir"
+
+first_json="$(get_json 1)"
+ugc_total_count=$(echo "$first_json" | jq '.data.ugc_total_count')
+echo "$first_json" | process_json
+# can also use while loop with i=$((i+1))
+# the calculation considers both ugc_total_count%num==0 and ugc_total_count%num>0
+for i in $(seq 2 $(((ugc_total_count+num-1)/num))); do
+ get_json "$i" | process_json &
+done
+
+wait
+aria2c -d "$download_dir" --auto-file-renaming=false --console-log-level=warn -i "$tmp_file"
+rm "$tmp_file"
diff --git a/home/xyz/.local/bin/curlncm b/home/xyz/.local/bin/curlncm
new file mode 100755
index 00000000..73a6e66f
--- /dev/null
+++ b/home/xyz/.local/bin/curlncm
@@ -0,0 +1,75 @@
+#!/bin/sh
+# rewrite TianyiShi2001's python script which rewrite NeteaseCloudMusicApi node.js api
+
+# references:
+# https://github.com/ytdl-org/youtube-dl/issues/18051#issuecomment-859964832
+# https://github.com/Binaryify/NeteaseCloudMusicApi
+# info about encrytion and api:
+# https://github.com/metowolf/NeteaseCloudMusicApi/wiki
+# https://github.com/darknessomi/musicbox/wiki
+
+# lan lan, aid=48860966, rid=793052426, example id=1397315179,1817498734
+# cheng ruan, aid=46703185, rid=792968433
+
+# trial and error to get dj_max, don't know why, maybe because it is 2^31 and it is the size limit of whatever type of the variable
+dj_max=2147483647
+dl_urls_tmp="$(mktemp)"
+# printf 'e82ckenh8dichen8' | hexdump -ve '/1 "%02x"'
+key='653832636b656e683864696368656e38'
+url='/api/song/enhance/player/url'
+request_id=$(date +'%s%3N')_$(seq -w 1 1000 | shuf -n1)
+user_agent='Mozilla/5.0 (Linux; U; Android 9; zh-cn; Redmi Note 8 Build/PKQ1.190616.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/12.5.22'
+cookie="$(printf '"appver":"8.0.0","versioncode":"140","buildver":"1623455100","resolution":"1920x1080","__csrf":"","os":"pc","requestId":"%s"' "$request_id")"
+
+die () {
+ echo "error: $*" >&2
+ exit 1
+}
+
+# artist, song, djradio id
+while getopts a:i:r: opt; do
+ case $opt in
+ a) aid="$OPTARG";;
+ i) ids="$OPTARG";;
+ r) rid="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+download_dir="${1:-"$PWD"}"
+[ -d "$download_dir" ] || mkdir -p "$download_dir"
+
+if [ -n "$ids" ]; then
+ # temporary solution, can improve by auto curl names
+ data="$(echo "$ids" | tr ',' '\n' | awk '{printf("%s\t%s\n",$0,"songname")}')"
+else
+ if [ -n "$rid" ]; then
+ data="$(curl -s -G --data-urlencode id="$rid" -d limit="$dj_max" 'https://music.163.com/djradio' | grep 'songlist\|tt f-thide' | sed -e 's/.*songlist-\(.*\)" class.*/\1/g' -e 's/.*title="\(.*\)".*/\1/g' | paste -sd '\t\n' | sort | tr '/' '_')"
+ # can only curl featured 50 songs for the artist, can improve
+ elif [ -n "$aid" ]; then
+ data="$(curl -s -G --data-urlencode id="$aid" 'https://music.163.com/artist' | grep '\[{.*}\]' | sed -e 's/.*>\[{/\[{/' -e 's/}\]<.*/}\]/' | jq -r '.[]|[.id,.name]|@tsv' | sort | tr '/' '_')"
+ fi
+ # awk code not print separator at beginning and end steal from:
+ # https://unix.stackexchange.com/a/581785/459013
+ # not sure awk one-liner or paste way which is better, need benchmark
+ ids="$(echo "$data" | awk -F'\t' '{printf "%s%s",sep,$1;sep=","}')"
+ #ids="$(echo "$data" | awk -F'\t' '{print $1}' | paste -sd ',')"
+fi
+
+# I don't fully understand following several lines of code
+# I rewrite TianyiShi2001's python script, he rewrites NeteaseCloudMusicApi
+text="$(printf '{"ids":"[%s]","br":999000,"header":{%s}}' "$ids" "$cookie")"
+message="nobody${url}use${text}md5forencrypt"
+digest="$(printf '%s' "$message" | openssl dgst -md5 -hex | awk '{print $2}')"
+params="$(printf '%s-36cd479b6b5-%s-36cd479b6b5-%s' "$url" "$text" "$digest")"
+encrypted_params="$(printf '%s' "$params" | openssl enc -aes-128-ecb -K "$key" | hexdump -ve '/1 "%02X"')"
+# curl default user agent header seems not working
+curl -s -A "$user_agent" -d params="$encrypted_params" 'https://interface3.music.163.com/eapi/song/enhance/player/url' | jq -r '.data|sort_by(.id)|.[].url' > "$dl_urls_tmp"
+[ "$(echo "$data" | wc -l)" -ne "$(wc -l < "$dl_urls_tmp")" ] && die "number of download urls doesn't match request"
+
+# can't download some music if live abroad, may need proxy or vpn
+# using user_agent, content-type header, cookie header, referer are not necessary? but feels faster
+# not sure about cookie header format for aria2c, this link shows that it's kinda messy, so I didn't use it
+# https://github.com/aria2/aria2/issues/545#issuecomment-650070869
+echo "$data" | awk -F'\t' '{printf(" out=%s_%s.mp3\n",$2,$1)}' | paste "$dl_urls_tmp" - -d '\n' | aria2c -U "$user_agent" --header='Content-Type: application/x-www-form-urlencoded' --referer='https://music.163.com' -d "$download_dir" --auto-file-renaming=false --console-log-level=warn -i-
+rm "$dl_urls_tmp"
diff --git a/home/xyz/.local/bin/curlqb b/home/xyz/.local/bin/curlqb
new file mode 100755
index 00000000..c3f6871b
--- /dev/null
+++ b/home/xyz/.local/bin/curlqb
@@ -0,0 +1,13 @@
+#!/bin/sh
+
+curl -s 'https://github.com/qbittorrent/search-plugins/wiki/Unofficial-search-plugins' | awk -F'"' '
+/require an account/ {exit}
+/\.py/ {
+ url=$2
+ getline
+ getline
+ getline
+ if($0 !~ /❗|✖/)
+ print url
+}
+' | xargs curl -s -Z -L --remote-name-all --create-dirs --output-dir "$1" --
diff --git a/home/xyz/.local/bin/gita b/home/xyz/.local/bin/gita
new file mode 100755
index 00000000..8d7e7f2a
--- /dev/null
+++ b/home/xyz/.local/bin/gita
@@ -0,0 +1,18 @@
+#!/bin/sh
+# note message string must come after options
+
+cmd=git
+
+while getopts cls f; do
+ case $f in
+ c|l|s) cmd="cfg -$f";;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+
+mes="${1:-refactor}"
+
+$cmd add -u
+$cmd commit -m "$mes"
+$cmd push
diff --git a/home/xyz/.local/bin/gitfork b/home/xyz/.local/bin/gitfork
new file mode 100755
index 00000000..cefc4f68
--- /dev/null
+++ b/home/xyz/.local/bin/gitfork
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+git clone "$1"
+cd "$(basename "$1" .git)" || exit
+git remote add upstream "$2"
+git branch fly
+git checkout fly
+git push --set-upstream origin fly
diff --git a/home/xyz/.local/bin/gitmetap b/home/xyz/.local/bin/gitmetap
new file mode 100755
index 00000000..21ae1c1b
--- /dev/null
+++ b/home/xyz/.local/bin/gitmetap
@@ -0,0 +1,17 @@
+#!/bin/sh
+# GIT META Print
+
+# -rw-r--r-- == binary 110100100 == octal 644
+# https://stackoverflow.com/a/1796009
+$1 ls-tree -r --name-only --full-tree HEAD | awk -v a="$2/" '{printf("%s%s\n",a,$0)}' | tr '\n' '\0' | xargs -0 ls -ldA -- | awk '{
+ k=0
+ for(i=0;i<=8;i++)
+ k+=((substr($1,i+2,1)~/[rwx]/)*2^(8-i))
+ if(k) {
+ for(i=10;$i && $i!="->";i++)
+ $9=$9" "$i
+ printf("%0o %s %s %s\n",k,$3,$4,$9)
+ }
+}' > "$3"
+
+#$1 ls-tree -r --name-only --full-tree HEAD | awk -v a="$2/" '{printf("%s%s\n",a,$0)}' | tr '\n' '\0' | xargs -0 ls -ldA -- | awk '{k=0;for(i=0;i<=8;i++)k+=((substr($1,i+2,1)~/[rwx]/)*2^(8-i));if(k){for(i=10;$i && $i!="->";i++)$9=$9" "$i;printf("%0o %s %s %s\n",k,$3,$4,$9)}}' > "$3"
diff --git a/home/xyz/.local/bin/gitmetar b/home/xyz/.local/bin/gitmetar
new file mode 100755
index 00000000..1bfdc150
--- /dev/null
+++ b/home/xyz/.local/bin/gitmetar
@@ -0,0 +1,7 @@
+#!/bin/sh
+# GIT META Read
+
+while read -r mod user group path; do
+ chown -hc "$user:$group" -- "$path"
+ [ "$mod" -ne 777 ] && chmod -c "$mod" -- "$path"
+done < "$1"
diff --git a/home/xyz/.local/bin/gitpu b/home/xyz/.local/bin/gitpu
new file mode 100755
index 00000000..fcc32be9
--- /dev/null
+++ b/home/xyz/.local/bin/gitpu
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+if [ -z "$1" ]; then
+ git checkout master
+ git pull upstream master
+ git push
+ git checkout fly
+ git merge --no-edit master
+ git push
+else
+ for dir ; do
+ git -C "$dir" checkout master
+ git -C "$dir" pull upstream master
+ git -C "$dir" push
+ git -C "$dir" checkout fly
+ git -C "$dir" merge --no-edit master
+ git -C "$dir" push
+ done
+fi
diff --git a/home/xyz/.local/bin/lastarg b/home/xyz/.local/bin/lastarg
new file mode 100755
index 00000000..58f1f14e
--- /dev/null
+++ b/home/xyz/.local/bin/lastarg
@@ -0,0 +1,5 @@
+#!/bin/sh
+# useage: lastarg "$@"
+
+shift $(($# - 1))
+echo "$1"
diff --git a/home/xyz/.local/bin/mmi b/home/xyz/.local/bin/mmi
new file mode 100755
index 00000000..e8df3f1e
--- /dev/null
+++ b/home/xyz/.local/bin/mmi
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+mi () {
+ make -B
+ sudo make install
+}
+
+origin="$PWD"
+cmd='mi'
+
+while getopts q opt; do
+ case $opt in
+ q) cmd='qmake6;mi';;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+
+if [ -z "$1" ]; then
+ eval "$cmd"
+else
+ for dir ; do
+ cd "$dir" || exit
+ eval "$cmd"
+ cd "$origin" || exit
+ done
+fi
diff --git a/home/xyz/.local/bin/mpva b/home/xyz/.local/bin/mpva
new file mode 100755
index 00000000..a54dfa99
--- /dev/null
+++ b/home/xyz/.local/bin/mpva
@@ -0,0 +1,15 @@
+#!/bin/sh
+# MPV Audio
+
+# fzf has --read0, maybe useful
+# use --loop-file for single file, better performance maybe
+
+if [ $# -eq 0 ]; then
+ find "$XDG_MUSIC_DIR" | fzf -m --print0
+fi | xargs -0 sh -c '
+if [ $# -eq 1 ] && ! [ -d "$1" ]; then
+ mpv --af= --loop-file=inf --video=no "$1"
+else
+ mpv --af= --shuffle --loop-playlist=inf --video=no "$@"
+fi
+' shell "$@"
diff --git a/home/xyz/.local/bin/mpvy b/home/xyz/.local/bin/mpvy
new file mode 100755
index 00000000..880d1ffa
--- /dev/null
+++ b/home/xyz/.local/bin/mpvy
@@ -0,0 +1,41 @@
+#!/bin/sh
+# MPV Yank/Youtube videos
+# references:
+# https://www.rockyourcode.com/til-how-to-watch-youtube-videos-with-mpv-and-keyboard-shortcuts/
+
+fps=30
+height=$SCR_HEIGHT
+url="$(xsel -ob)"
+flag=s
+
+# option f and h may do nothing if redownload? since same filename exist. yt-dlp won't download same file even without --auto-file-renameing=false. how improve? pass argument to aria2c?
+while getopts Aabd:f:h:su: opt; do
+ case $opt in
+ # s: streaming, a: aria2c then mpv, A: aria2c
+ A|a|s) flag=$opt;;
+ b) format='bestvideo+bestaudio/best';;
+ d) download_dir="$OPTARG";;
+ f) fps="$OPTARG";;
+ h) height="$OPTARG";;
+ u) url="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+if [ -z "$format" ]; then
+ vformat="[height<=?$height][fps<=?$fps][vcodec!^=?vp9][vcodec!^=?av01]"
+ # usually get .mp4 video + .webm audio on youtube, yt-dlp needs to merge them to .mkv
+ # it used to cause problem, but I forget
+ format="bestvideo$vformat+bestaudio/best$vformat"
+fi
+
+case $flag in
+ # here if use --write-sub, mpv doesn't recognize subtitles?
+ # --embed-subs is a little bit better, but still worse then direct streaming
+ A) yt-dlp -f "$format" --embed-subs -P "${download_dir:-"$XDG_DOWNLOAD_DIR/mpvy/"}" --sponsorblock-remove all "$url";;
+ a) yt-dlp -f "$format" --embed-subs -P "${download_dir:-"$XDG_DOWNLOAD_DIR/mpvy/"}" --sponsorblock-remove all "$url" --exec 'mpv --fs --speed=2';;
+ s) mpv --ytdl-format="$format" --ytdl-raw-options='write-sub=' --fs --speed=2 "$url";;
+esac
+# not sure if this is the best practice, but it seems working ;)
+status=$?
+[ $status -ne 0 ] && notify-send 'mpvsel failed'
+exit $status
diff --git a/home/xyz/.local/bin/mvln b/home/xyz/.local/bin/mvln
new file mode 100755
index 00000000..fb540390
--- /dev/null
+++ b/home/xyz/.local/bin/mvln
@@ -0,0 +1,30 @@
+#!/bin/sh
+# edge cases give me headache
+
+lns () {
+ # prevent `mvln file1 file1` or `mvln dir1/file1 dir1/`
+ # which means `ln -s samename samename` or `ln -s dir/file dir/`
+ # both $1 and $2 here are realpath
+ [ "$1" != "$2" ] && ln -s -- "$1" "$2"
+}
+
+mv -i -- "$@"
+# consider `mvln file1 dir/file2`
+if [ $# -eq 2 ] && ! [ -d "$2" ]; then
+ # use realpath here
+ lns "$(realpath "$2")" "$(realpath "$1")"
+else
+ dir="$(realpath -- "$(lastarg "$@")")"
+ # steal from https://unix.stackexchange.com/a/353833/459013
+ while [ $# -gt 1 ]; do
+ to="$(realpath -- "$1")"
+ # prevent `mvln dir1/ dir1/`
+ if [ "$dir" != "$to" ]; then
+ lns "$dir/$(basename "$1")" "$to"
+ fi
+ shift
+ done
+fi
+
+# for test
+#rm -rf ~/test/A\ A/; mkdir -p ~/test/A\ A/; cp -r ~/test/0t/ ~/test/A\ A/1t/; mvln ~/test/A\ A/1t/* ~/test/A\ A/; tree ~/test/A\ A/
diff --git a/home/xyz/.local/bin/mvt b/home/xyz/.local/bin/mvt
new file mode 100755
index 00000000..716c0eaa
--- /dev/null
+++ b/home/xyz/.local/bin/mvt
@@ -0,0 +1,8 @@
+#!/bin/sh
+# emulate mv -t, for use with `find ... -exec mvt ... '{}' \+`, more POSIX compliant
+# example: mvt ./dir/ -i -- file1 file2
+
+dist="$1"
+shift
+# not use -- here, use -- when use mvt, so I can specify -f or -i switch before -- when use mvt
+mv "$@" "$dist"
diff --git a/home/xyz/.local/bin/mvtr b/home/xyz/.local/bin/mvtr
new file mode 100755
index 00000000..850f8dba
--- /dev/null
+++ b/home/xyz/.local/bin/mvtr
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+# can use ls pipe to sed pipe to bash, similar to eval? see comment at link:
+# link also show perl-rename approach
+# https://linuxconfig.org/rename-all-files-from-uppercase-to-lowercase-characters
+# if only change ' ' to '_' `rename` might be sufficient, for upper to lower case might need perl-rename if want concise
+
+# ./_filename will be renamed ./filename, not what I want, need improve
+# -exec can't replace -execdir here, can write a -exec version
+
+find "$@" -depth -execdir sh -c 'dest="$(echo "$1" | tr -d "\047" | sed -E -e "s/([[:lower:]])([[:upper:]])/\1_\2/g" | tr "[:upper:] " "[:lower:]_" | tr -s "[:punct:]" | sed -E -e "s#/-#/#g" -e "s/_([[:punct:]])/\1/g" -e "s/([[:punct:]])_/\1/g" | tr -s "[:punct:]")"; [ -e "$dest" ] || mv -v -- "$1" "$dest"' shell '{}' \;
+
+# for test
+#mkdir -p ~/test/A\ A/; rm -rf ~/test/A\ A/1t/; cp -r ~/test/0t/ ~/test/A\ A/1t/; time mvtr ~/test/A\ A/1t/; tree ~/test/A\ A/1t/
diff --git a/home/xyz/.local/bin/o b/home/xyz/.local/bin/o
new file mode 100755
index 00000000..d70a6d76
--- /dev/null
+++ b/home/xyz/.local/bin/o
@@ -0,0 +1,25 @@
+#!/bin/sh
+
+# useful links
+# https://stackoverflow.com/questions/3430330/best-way-to-make-a-shell-script-daemon
+# https://serverfault.com/questions/117152/do-background-processes-get-a-sighup-when-logging-off
+# https://wiki.archlinux.org/title/default_applications
+
+# I don't care about errors, I don't want to handle errors, just shut up please.
+# nohup seems not necessary if don't care about daemon SIGHUP requirement
+
+# when close a shell script's stdout or stderr with `>&-` or `2>&-`, `xsel -ib` in that script has no effect
+# https://github.com/kfish/xsel/issues/43
+# using `>&-` or `2>&-` doesn't completely close mpv's output when run sth. like `o mpv file.mkv`
+# base on above observations, I choose to use `>/dev/null 2>&1` instead
+
+if [ $# -eq 1 ] && [ -e "$1" ] && { ! [ -x "$1" ] || [ -d "$1" ];}; then
+ case "$1" in
+ # libreoffice, please don't let firefox eat your shit
+ *.docx|*.pptx) cmd=libreoffice;;
+ *) cmd=xdg-open;;
+ esac
+ nohup "$cmd" "$1" 0<&- >/dev/null 2>&1 &
+else
+ nohup "$@" 0<&- >/dev/null 2>&1 &
+fi
diff --git a/home/xyz/.local/bin/orgext b/home/xyz/.local/bin/orgext
new file mode 100755
index 00000000..8f00804f
--- /dev/null
+++ b/home/xyz/.local/bin/orgext
@@ -0,0 +1,18 @@
+#!/bin/sh
+
+outdir () {
+ find . -type f -execdir mvt "$PWD" -- '{}' \+
+ find . -mindepth 1 -maxdepth 1 -type d -execdir rmdir -- '{}' \+
+}
+
+indir () {
+ # https://stackoverflow.com/questions/1842254/how-can-i-find-all-of-the-distinct-file-extensions-in-a-folder-hierarchy
+ find . -maxdepth 1 -type f | awk -F. '!a[$NF]++{print $NF}' | xargs mkdir --
+ find . -mindepth 1 -maxdepth 1 -type d -execdir basename -az -- '{}' \+ | xargs -0 -I _ find . -maxdepth 1 -type f -name '*._' -execdir mvt '_' -- '{}' \+
+}
+
+case "$1" in
+ '-o') outdir;;
+ '-i') indir;;
+ *) outdir; indir;;
+esac
diff --git a/home/xyz/.local/bin/reco b/home/xyz/.local/bin/reco
new file mode 100755
index 00000000..d56e61c2
--- /dev/null
+++ b/home/xyz/.local/bin/reco
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+# useful urls:
+# https://github.com/LukeSmithxyz/voidrice/blob/master/.local/bin/dmenurecord
+# https://wiki.archlinux.org/title/FFmpeg#Screen_capture
+# https://trac.ffmpeg.org/wiki/Capture/Desktop
+
+infofile="/tmp/recoinfo"
+recodir="$XDG_VIDEOS_DIR/recordings/"
+mkdir -p "$recodir"
+
+if [ -e "$infofile" ]; then
+ read -r pid tmpfile < "$infofile"
+ kill "$pid"
+ notify-send 'finish recording, start converting'
+ ffmpeg -i "$tmpfile" "$recodir/$(time.uuid).mkv"
+ notify-send 'finish converting'
+ rm "$tmpfile" "$infofile"
+else
+ tmpfile="$(mktemp --suffix '.mkv')"
+ notify-send 'start recording'
+ # arch wiki way, no audio, less cpu use during capturing (fast?), large file size, need convert afterward
+ xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -y -loglevel quiet -f x11grab -framerate 25 -s "$2"x"$3" -i "$DISPLAY+$4,$5" -c:v ffvhuff "$1" & echo $!' shell "$tmpfile" | xargs -I {} printf '%s\t%s' '{}' "$tmpfile" > "$infofile"
+ # another way to get subshell ffmpeg child pid
+ #xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -y -f x11grab -framerate 25 -s "$2"x"$3" -i "$DISPLAY+$4,$5" -c:v ffvhuff "$1"' shell "$tmpfile" &
+ #printf '%s\t%s' "$(ps -o pid= --ppid $!)" "$tmpfile" > "$infofile"
+fi
diff --git a/home/xyz/.local/bin/sbar b/home/xyz/.local/bin/sbar
new file mode 100755
index 00000000..32e46c67
--- /dev/null
+++ b/home/xyz/.local/bin/sbar
@@ -0,0 +1,94 @@
+#!/bin/sh
+# steal from pystardust, GPL3 license: https://github.com/pystardust/sbar
+# modified to fit my own need
+
+# INIT
+printf '%s' "$$" > "$XDG_CACHE_HOME/pidofbar"
+sec=0
+
+bool () {
+ read str
+ if [ "$str" = "on" ] || [ "$str" = "up" ] || [ "$str" = "Connected" ]; then
+ echo 1
+ else
+ echo 0
+ fi
+}
+
+# MODULES
+update_time () {
+ time="$(date '+%a %m/%d %H:%M') $(TZ=Asia/Shanghai date '+/%d %H:')"
+}
+
+update_cap () {
+ cap="$(if xset q | grep -q "Caps Lock: *on"; then echo A; else echo a; fi)"
+}
+
+update_net () {
+ net="$(bool < /sys/class/net/wlp6s0/operstate)"
+}
+
+update_vpn () {
+ vpn="$(mullvad status | awk '{print $3}' | bool)"
+}
+
+update_vol () {
+ # $(NF-1) for both alsa and pulseaudio
+ vol="$(amixer get Master | awk -F'[][]' 'END{printf("%d %s",($(NF-1)=="on")?1:0,$2)}')"
+}
+
+update_mic () {
+ # $(NF-1) for both alsa and pulseaudio
+ mic="$(amixer get Capture | awk -F'[][]' 'END{print $(NF-1)}' | bool)"
+}
+
+update_bat () {
+ bat="$(cat /sys/class/power_supply/BAT1/capacity)%"
+}
+
+# For calcurse users, refer https://github.com/pystardust/automeet
+#update_event () {
+# event="$(calcurse -n | sed 1d | \
+# sed -E "s_^ *\[(.*):(.*)\] ([^\t]*)\t?.*_[\1h \2m->\3]_")"
+# [ "[]" = "$event" ] && event=""
+#}
+
+# modules that don't update on their own need to be run at the start for getting their initial value
+update_vol
+update_mic
+update_cap
+update_vpn
+
+display () {
+ xsetroot -name "$(echo "$time | N $net V $vpn | M $vol C $mic | $cap | $bat")"
+}
+
+# SIGNALLING
+# trap "<function>;display" "RTMIN+n"
+trap "update_mic;display" "RTMIN"
+trap "update_vol;display" "RTMIN+1"
+# xev can't read my toggle internet keyboard key, don't know what key to use in sxhkd to send signal
+#trap "update_net;display" "RTMIN+2"
+trap "update_cap;display" "RTMIN+3"
+trap "update_vpn;display" "RTMIN+4"
+# to update it from external commands
+## kill -m "$(cat "$XDG_CACHE_HOME/pidofbar")"
+# where m = 34 + n
+
+while true; do
+ # next line of code seems make hotkeys that send kill signals more responsive? not fully understood
+ sleep 1 & wait && {
+ # to update item ever n seconds with a offset of m
+ ## [ $((sec % n)) -eq m ] && udpate_item
+ [ $((sec % 5 )) -eq 0 ] && update_time # update time every 5 seconds
+ [ $((sec % 5 )) -eq 0 ] && update_net
+ # mullvad like writing log when asking it about status
+ #[ $((sec % 5 )) -eq 0 ] && update_vpn
+ [ $((sec % 60)) -eq 0 ] && update_bat
+ #[ $((sec % 300)) -eq 1 ] && update_event
+
+ # how often the display updates ( 5 seconds )
+ [ $((sec % 5 )) -eq 0 ] && display
+ sec=$((sec + 1))
+ }
+done
diff --git a/home/xyz/.local/bin/shufwall b/home/xyz/.local/bin/shufwall
new file mode 100755
index 00000000..5b249e12
--- /dev/null
+++ b/home/xyz/.local/bin/shufwall
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if [ -z "$1" ]; then
+ file=$(find -L "$XDG_PICTURES_DIR/wallpapers" -type f | shuf -n 1)
+else
+ file=$(find -L "$@" -maxdepth 1 -type f | shuf -n 1)
+fi
+
+display -resize "${SCR_WIDTH}x$SCR_HEIGHT" -backdrop -window root "$file"
diff --git a/home/xyz/.local/bin/time.uuid b/home/xyz/.local/bin/time.uuid
new file mode 100755
index 00000000..11cc67ad
--- /dev/null
+++ b/home/xyz/.local/bin/time.uuid
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+# echo current nanosecond since epoch and alpha-numerically ordered UUID
+# https://stackoverflow.com/questions/28681650/generate-alpha-numerically-ordered-uuids-over-time?noredirect=1&lq=1
+# https://askubuntu.com/questions/342842/what-does-this-command-mean-awk-f-print-4
+echo "$(date '+%s.%N').$(uuidgen -t | awk -F- '{OFS="-"; print $3,$2,$1,$4,$5}')"
diff --git a/home/xyz/.local/bin/topa b/home/xyz/.local/bin/topa
new file mode 100755
index 00000000..e921bc31
--- /dev/null
+++ b/home/xyz/.local/bin/topa
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+o alacritty -e htop
+o alacritty -e radeontop -c
+o alacritty -e sudo iotop
+o alacritty -e sudo nethogs
diff --git a/home/xyz/.local/bin/upd b/home/xyz/.local/bin/upd
new file mode 100755
index 00000000..b3839539
--- /dev/null
+++ b/home/xyz/.local/bin/upd
@@ -0,0 +1,126 @@
+#!/bin/sh
+
+all () {
+ fast
+ usb
+ qb
+ kg
+ ncm
+ refl
+ gall
+}
+
+# not in all
+clean () {
+ nsxiv -c
+ # my ways
+ # -exec can't replace -execdir here
+ find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -empty -execdir rmdir -- '{}' \+
+ # -exec can replace -execdir here
+ #find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -execdir rmdir --ignore-fail-on-non-empty -- '{}' \+
+ # nsxiv man page way
+ #find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -empty ! -name '.' -exec rmdir -- '{}' \;
+
+ rm "$HOME/.mozilla/firefox/xxxxxxxx.fly/prefs.js.backup."*
+
+ # https://unix.stackexchange.com/questions/92095/reset-atq-list-to-zero
+ sudo systemctl stop atd
+ echo 0 | sudo tee /var/spool/atd/.SEQ > /dev/null
+ sudo systemctl start atd
+}
+
+# basic daily stuff
+fast () {
+ pac
+ misc
+}
+
+gall () {
+ gallery-dl --download-archive "$XDG_DOCUMENTS_DIR/database/gallery-dl.sqlite3" -d "$XDG_PICTURES_DIR/anime/gallery-dl/" -i "$XDG_CONFIG_HOME/myconf/gallery_urls"
+}
+
+userjs () {
+ kill $(pidof "$BROWSER")
+ "$HOME/.mozilla/firefox/xxxxxxxx.fly/prefsCleaner.sh" -s
+ "$HOME/.mozilla/firefox/xxxxxxxx.fly/updater.sh" -us
+}
+
+kg () {
+ curlkg -u649b9e82272a348b -- "$XDG_MUSIC_DIR/not_pure/lan_lan/kg/"
+ curlkg -u64949d822c25328c -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/kg/"
+}
+
+misc () {
+ cfg -c submodule foreach git pull
+ "$EDITOR" +PlugUpgrade +PlugClean! +PlugUpdate +qa
+ tldr --update
+ sudo hardcode-fixer
+ userjs
+}
+
+ncm () {
+ curlncm -a48860966 -- "$XDG_MUSIC_DIR/not_pure/lan_lan/ncm/artist/"
+ curlncm -a46703185 -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/ncm/artist/"
+ curlncm -a30382647 -- "$XDG_MUSIC_DIR/not_pure/qi_tian_sakura/ncm/artist/"
+
+ curlncm -r793052426 -- "$XDG_MUSIC_DIR/not_pure/lan_lan/ncm/djradio/"
+ curlncm -r792968433 -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/ncm/djradio/"
+ curlncm -r792042397 -- "$XDG_MUSIC_DIR/not_pure/qi_tian_sakura/ncm/djradio/"
+}
+
+pac () {
+ pacpacs="$(sudo pacman --noconfirm -Syu | tee /dev/tty | grep '^Packages' | cut -d' ' -f3-)"
+ aurpacs="$(paru --noconfirm -aSyu | tee /dev/tty | grep '^Aur' | cut -d' ' -f3-)"
+ # part steal from aur comment
+ # sometimes "ERROR: Failure while downloading": https://github.com/neovim/neovim/issues/15709
+ rm -rf ~/.cache/paru/clone/neovim-nightly-bin/ && yes 1 | PARU_PAGER=cat paru --rebuild --redownload neovim-nightly-bin
+ sudo pacman -Fy
+ # pacdiff default use pacman database, so no need `sudo -E` for find, but will be a little bit slower
+ log="$log
+updated pacman packages: $pacpacs
+updated aur packages: $aurpacs
+pacdiff: $(pacdiff -o | tr '\n' ' ')
+"
+}
+
+qb () {
+ rm -r -- "$HOME/programs/qbittorrent_search_plugins/"
+ curlqb "$HOME/programs/qbittorrent_search_plugins/"
+}
+
+refl () {
+ sudo reflector --save /etc/pacman.d/mirrorlist --latest 200 --sort rate
+}
+
+usb () {
+ cfg -c push usb
+ cfg -l push usb
+ cfg -s push
+ git --git-dir="$XDG_DOCUMENTS_DIR/notes/.git/" --work-tree="$XDG_DOCUMENTS_DIR/notes/" push usb
+}
+
+
+if [ $# -eq 0 ]; then
+ fast
+else
+ while getopts acfgjkmnpqru opt; do
+ case $opt in
+ a)all;;
+ # not in all
+ c)clean;;
+ f)fast;;
+ g)gall;;
+ j)userjs;;
+ k)kg;;
+ m)misc;;
+ n)ncm;;
+ p)pac;;
+ q)qb;;
+ r)refl;;
+ u)usb;;
+ \?)exit 1;;
+ esac
+ done
+fi
+
+printf '%s' "$log"
diff --git a/home/xyz/.local/bin/vinfo b/home/xyz/.local/bin/vinfo
new file mode 100755
index 00000000..190de192
--- /dev/null
+++ b/home/xyz/.local/bin/vinfo
@@ -0,0 +1,4 @@
+#!/bin/sh
+
+# steal from https://github.com/HiPhish/info.vim
+"$EDITOR" -RM +"Info $1 $2" +only
diff --git a/home/xyz/.local/bin/wh b/home/xyz/.local/bin/wh
new file mode 100755
index 00000000..d20f0de6
--- /dev/null
+++ b/home/xyz/.local/bin/wh
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+# blue, see `man terminfo`
+setaf="$(tput setaf 4)"
+sgr0="$(tput sgr0)"
+
+# dash `command -V "$@"` will only output first command's type, same as `type`, but different than posix specification? so not use here
+for cmd in type whatis whereis which "pacman -Qo --color always"; do
+ printf '\n%s\n%s\n' "$setaf$cmd $*$sgr0" "$($cmd "$@" 2>&1)"
+ #printf '\n\033[0;34m%s\033[0m\n%s\n' "$setaf$cmd $*$sgr0" "$($cmd "$@" 2>&1)"
+done | "$PAGER"
diff --git a/home/xyz/.local/bin/xmq b/home/xyz/.local/bin/xmq
new file mode 100755
index 00000000..83eca0f6
--- /dev/null
+++ b/home/xyz/.local/bin/xmq
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+xdg-mime query filetype "$1" | tee /dev/tty | xargs xdg-mime query default
diff --git a/home/xyz/.local/share/applications/file.desktop b/home/xyz/.local/share/applications/file.desktop
new file mode 100644
index 00000000..5d272b17
--- /dev/null
+++ b/home/xyz/.local/share/applications/file.desktop
@@ -0,0 +1,4 @@
+[Desktop Entry]
+Type=Application
+Name=File Manager
+Exec=/usr/bin/alacritty --working-directory %u
diff --git a/home/xyz/.local/share/weechat/python/autoload/weechat-matrix.py b/home/xyz/.local/share/weechat/python/autoload/weechat-matrix.py
new file mode 120000
index 00000000..d9b2d7c7
--- /dev/null
+++ b/home/xyz/.local/share/weechat/python/autoload/weechat-matrix.py
@@ -0,0 +1 @@
+/usr/share/weechat/python/weechat-matrix.py \ No newline at end of file
diff --git a/home/xyz/.profile b/home/xyz/.profile
new file mode 100644
index 00000000..464e9938
--- /dev/null
+++ b/home/xyz/.profile
@@ -0,0 +1,90 @@
+#!/bin/sh
+
+# here `. ~/.bashrc` same as `source ~/.bashrc`, see `source filename` in `man bash`, and `. file` in `man dash`
+# `. file` is POSIX compliant, while `source file` is not
+# https://github.com/koalaman/shellcheck/wiki/SC3046
+#[[ -f ~/.bashrc ]] && . ~/.bashrc
+[ -f "$HOME/.bashrc" ] && . "$HOME/.bashrc"
+
+export XDG_CONFIG_HOME="$HOME/.config/"
+export XDG_CACHE_HOME="$HOME/.cache/"
+export XDG_DATA_HOME="$HOME/.local/share/"
+
+. "$XDG_CONFIG_HOME/user-dirs.dirs"
+export XDG_DESKTOP_DIR
+export XDG_DOWNLOAD_DIR
+export XDG_TEMPLATES_DIR
+export XDG_PUBLICSHARE_DIR
+export XDG_DOCUMENTS_DIR
+export XDG_MUSIC_DIR
+export XDG_PICTURES_DIR
+export XDG_VIDEOS_DIR
+
+PATH="$(find "$HOME/.local/bin" -type d -exec printf '%s:' '{}' \+)$PATH"
+export PATH
+export HISTSIZE=10000
+export HISTFILESIZE=10000
+
+export EDITOR=nvim
+export BROWSER=firefox
+
+export PAGER=less
+# -X seems can keep the output if exit less?
+# -F is useful when sdcv need user to manually select similar word, after selection if no -F less will not quit if one screen
+# but other situation seems less use -F as default?
+# steal from sdcv arch wiki
+export LESS='-FRX'
+export SDCV_PAGER="$PAGER"
+
+# not posix
+export MANPAGER='nvim -M +Man!'
+export MANSECT='1p:1:n:l:8:3p:3:0p:0:2:5:4:9:6:7'
+
+export SSH_AUTH_SOCK="$XDG_RUNTIME_DIR/ssh-agent.socket"
+export INPUTRC="$XDG_CONFIG_HOME/readline/inputrc"
+#export QT_QPA_PLATFORMTHEME=qt5ct
+export QT_QPA_PLATFORMTHEME=gtk2
+#export QT_STYLE_OVERRIDE=kvantum
+export SXHKD_SHELL=sh
+export _ZO_ECHO=1
+# enable color for `tree` command, not forced
+export CLICOLOR=1
+# for pacdiff, without using aur neovim-drop-in or neovim-symlinks
+export DIFFPROG='nvim -d'
+
+# use sudo find for some files or dirs that has no permission ex: ~/.cache/paru/clone/
+#export FZF_DEFAULT_COMMAND="fd --no-ignore --hidden --exclude .git"
+#export FZF_CTRL_T_COMMAND="fd --absolute-path --no-ignore --hidden --exclude .git"
+#export FZF_ALT_C_COMMAND="fd --no-ignore --hidden --type d --exclude .git"
+export FZF_DEFAULT_COMMAND="sudo find . -mindepth 1 -path '*/\.git' -prune -o -print"
+# https://askubuntu.com/questions/444551/get-absolute-path-of-files-using-find-command
+# following two lines if use "" on the outermost, will not perfom expected, not sure why
+export FZF_CTRL_T_COMMAND='sudo find "$PWD" -mindepth 1 -path "*/\.git" -prune -o -print'
+#export FZF_CTRL_T_COMMAND='sudo find "$(pwd)" -path "*/\.git" -prune -o -print'
+# ~+ is bashism
+#export FZF_CTRL_T_COMMAND="sudo find ~+ -path '*/\.git' -prune -o -print"
+export FZF_ALT_C_COMMAND="sudo find . -mindepth 1 -path '*/\.git' -prune -o -type d -print"
+
+# for clipmenu
+# set clipmenud to store clipboard only, don't store selection (primary)
+#export CM_SELECTIONS="clipboard"
+# X11, copy / close program / paste to another program, if 0 will paste nothing
+#export CM_OWN_CLIPBOARD=1
+#export CM_MAX_CLIPS=8
+
+export SCR_WIDTH=1600
+export SCR_HEIGHT=900
+
+# GDK_SCALE and GDK_DPI_SCALE should be use at the same time
+# more see bookmarks about dpi
+# not sure if correct
+#export GDK_SCALE=1.36
+#export GDK_DPI_SCALE=0.73
+# correct but not sure if fits me
+#export GDK_SCALE=2
+#export GDK_DPI_SCALE=0.5
+
+# startx when login, should be put after environmental variables for .xinitrc to use
+if [ -z "$DISPLAY" ] && [ "$XDG_VTNR" -eq 1 ]; then
+ exec startx
+fi
diff --git a/home/xyz/.xinitrc b/home/xyz/.xinitrc
new file mode 100644
index 00000000..95f87335
--- /dev/null
+++ b/home/xyz/.xinitrc
@@ -0,0 +1,60 @@
+#!/bin/sh
+
+userresources="$HOME/.Xresources"
+usermodmap="$HOME/.Xmodmap"
+sysresources=/etc/X11/xinit/.Xresources
+sysmodmap=/etc/X11/xinit/.Xmodmap
+
+# merge in defaults and keymaps
+
+if [ -f $sysresources ]; then
+ xrdb -merge $sysresources
+fi
+
+if [ -f $sysmodmap ]; then
+ xmodmap $sysmodmap
+fi
+
+if [ -f "$userresources" ]; then
+ xrdb -merge "$userresources"
+fi
+
+if [ -f "$usermodmap" ]; then
+ xmodmap "$usermodmap"
+fi
+
+# start some nice programs
+
+if [ -d /etc/X11/xinit/xinitrc.d ] ; then
+ for f in /etc/X11/xinit/xinitrc.d/?*.sh ; do
+ [ -x "$f" ] && . "$f"
+ done
+ unset f
+fi
+
+export GTK_IM_MODULE=fcitx
+export QT_IM_MODULE=fcitx
+export XMODIFIERS=@im=fcitx
+
+if [ -e "$XDG_PICTURES_DIR/wallpapers/wallpaper" ]; then
+ display -window root "$XDG_PICTURES_DIR/wallpapers/wallpaper" &
+else
+ shufwall &
+fi
+
+#clipmenud &
+dunst &
+fcitx5 -d
+redshift &
+sbar &
+sxhkd &
+udiskie &
+# xorg-server 21.1.1-2 set correct dpi for my computer, but I choose to take the blue pill
+# Attention, don't use & at the end otherwise dwm status bar won't have proper dpi.
+# xorg-server 21.1.1-3 "fixed" it, so no need now
+#xrandr --dpi 96
+# default fastest windows 10 keyboard repeat delay and rate
+# without editing registry, using filter key, or other third party program
+# see http://stereopsis.com/keyrepeat/
+xset r rate 250 30
+exec dwm